%define anolis_release 6
# Break lines according to Unicode rules
%bcond_without perl_Test2_Suite_enables_unicode

Name:           perl-Test2-Suite
Version:        0.000145
Release:        %{anolis_release}%{?dist}
Summary:        Set of tools built upon the Test2 framework
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/Test2-Suite
Source0:        https://cpan.metacpan.org/authors/id/E/EX/EXODIST/Test2-Suite-%{version}.tar.gz
Patch0:         Test2-Suite-0.000140-add_perl.patch
BuildArch:      noarch
BuildRequires:  coreutils
BuildRequires:  make
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(strict)
BuildRequires:  perl(warnings)
# Run-time:
BuildRequires:  perl(B)
BuildRequires:  perl(base)
BuildRequires:  perl(Carp)
BuildRequires:  perl(Data::Dumper)
BuildRequires:  perl(Exporter)
BuildRequires:  perl(File::Spec)
BuildRequires:  perl(File::Temp)
BuildRequires:  perl(Importer) >= 0.024
BuildRequires:  perl(List::Util)
BuildRequires:  perl(Module::Pluggable) >= 2.7
BuildRequires:  perl(overload)
BuildRequires:  perl(Scalar::Util)
BuildRequires:  perl(Scope::Guard)
BuildRequires:  perl(Sub::Info) >= 0.002
BuildRequires:  perl(Term::Table) >= 0.013
BuildRequires:  perl(Term::Table::Cell)
BuildRequires:  perl(Term::Table::LineBreak)
BuildRequires:  perl(Term::Table::Util)
BuildRequires:  perl(Test2::API) >= 1.302176
BuildRequires:  perl(Test2::API::Context)
BuildRequires:  perl(Test2::Event)
BuildRequires:  perl(Test2::Event::Exception)
# Test2::Event::Note loaded by send_event()
BuildRequires:  perl(Test2::Event::Note)
# Test2::Event::Skip loaded by send_event()
BuildRequires:  perl(Test2::Event::Skip)
BuildRequires:  perl(Test2::EventFacet)
BuildRequires:  perl(Test2::EventFacet::Info::Table)
BuildRequires:  perl(Test2::EventFacet::Trace)
BuildRequires:  perl(Test2::Hub::Interceptor)
BuildRequires:  perl(Test2::Hub::Subtest)
BuildRequires:  perl(Test2::IPC)
BuildRequires:  perl(Test2::Tools::Tiny)
BuildRequires:  perl(Test2::Util)
BuildRequires:  perl(Test2::Util::HashBase)
BuildRequires:  perl(Test2::Util::Trace)
BuildRequires:  perl(threads)
BuildRequires:  perl(Time::HiRes)
BuildRequires:  perl(utf8)
BuildRequires:  perl(vars)
# Optional run-time:
# Sub::Util or Sub::Name
BuildRequires:  perl(Sub::Util)
%if %{with perl_Test2_Suite_enables_unicode}
BuildRequires:  perl(Unicode::GCString)
%endif
# Tests:
BuildRequires:  perl(IO::Handle)
BuildRequires:  perl(PerlIO)
BuildRequires:  perl(Test2::EventFacet::Assert)
BuildRequires:  perl(Test2::Formatter::TAP)
Requires:       perl(Data::Dumper)
Requires:       perl(Importer) >= 0.024
Requires:       perl(Module::Pluggable) >= 2.7
Requires:       perl(Sub::Info) >= 0.002
# Sub::Util or Sub::Name
Suggests:       perl(Sub::Util)
Requires:       perl(Term::Table) >= 0.013
Requires:       perl(Test2::API) >= 1.302176
Requires:       perl(Test2::Event)
# Test2::Event::Note loaded by send_event()
Requires:       perl(Test2::Event::Note)
# Test2::Event::Skip loaded by send_event()
Requires:       perl(Test2::Event::Skip)
Requires:       perl(Test2::EventFacet)
Requires:       perl(threads)
Requires:       perl(utf8)
%if %{with perl_Test2_Suite_enables_unicode}
# Unicode::GCString for formating double-width strings
Recommends:     perl(Unicode::GCString)
%endif
# perl-Test2-AsyncSubtest-0:0.000020-1.fc28 merged
Provides:       perl-Test2-AsyncSubtest = %{version}-%{release}
Obsoletes:      perl-Test2-AsyncSubtest < 0.000020-2
# perl-Test2-Workflow-0:0.000018-4.fc27 merged
Provides:       perl-Test2-Workflow = %{version}-%{release}
Obsoletes:      perl-Test2-Workflow < 0.000018-5

# Remove under-specified dependencies
%global __requires_exclude %{?__requires_exclude:%{__requires_exclude}|}^perl\\((Importer|Module::Pluggable|Sub::Info|Term::Table|Test2::API)\\)$
# Remove private modules
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\(MyTest::Target\\)$
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_libexecdir}

%description
Rich set of tools, plugins, bundles, etc. built upon the Test2 testing
library. If you are interested in writing Perl tests this is the distribution
for you.

%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{EVR}
Requires:       perl-Test-Harness
Requires:       perl(Test::Compile) >= 1.1.0

%description tests
Tests from %{name}. Execute them
with "%{_libexecdir}/%{name}/test".

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n Test2-Suite-%{version}
# Help generators to recognize Perl scripts
for F in `find . -type f -name '*.t'`; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!\s*perl}{$Config{startperl}}' "$F"
    chmod +x "$F"
done

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
%{_fixperms} %{buildroot}/*
# Install tests
mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t %{buildroot}%{_libexecdir}/%{name}
cat > %{buildroot}%{_libexecdir}/%{name}/test << 'EOF'
#!/bin/sh
cd %{_libexecdir}/%{name} && exec prove -r -I . -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}%{_libexecdir}/%{name}/test

%check
unset AUTHOR_TESTING
make test

%files
%license LICENSE
%{perl_vendorlib}/*
%{_mandir}/man3/*

%files doc
%doc Changes README

%files tests
%{_libexecdir}/%{name}

%changelog
* Wed Feb 8 2023 Funda Wang <fundawang@yeah.net> - 0.000145-6
- Import package for anolis 23
